/**
 * ジャンケンの審判を表すクラス。
 */
public class Judge
{
    /**
	 * ジャンケンを開始する。
	 * 
	 * @param player1
	 *            判定対象プレイヤー1
	 * @param player2
	 *            判定対象プレイヤー2
	 */
    public void startJanken(Player player1, Player player2)
    {
        // ジャンケンの開始を宣言する
        System.out.println("Start Janken (chapter 3 version)\n");

        // ジャンケンを3回行う
        for (int cnt = 0; cnt < 3; cnt++)
        {
            // 何回戦目か表示する
            System.out.println("Game " + (cnt + 1));

            // プレイヤーの手を見て、どちらが勝ちかを判定する。
            Player winner = judgeJanken(player1, player2);

            if (winner != null)
            {
                // 勝者を表示する
                System.out.println(winner.getName() + " is winner!\n");

                // 勝ったプレイヤーへ結果を伝える
                winner.notifyResult(true);
            }
            else
            {
                // 引き分けの場合
                System.out.println("draw.\n");
            }
        }

        // ジャンケンの終了を宣言する
        System.out.println("Game over.\n");

        // 最終的な勝者を判定する
        Player finalWinner = judgeFinalWinner(player1, player2);

        // 結果の表示
        System.out.print(
            player1.getWinCount() + " vs " + player2.getWinCount() + ", ");

        if (finalWinner != null)
        {
            System.out.println(finalWinner.getName() + " is final winner!\n");
        }
        else
        {
            System.out.println("a draw game!\n");
        }
    }

    /**
	 * 「ジャンケン、ポン！」と声をかけ、 プレイヤーの手を見て、どちらが勝ちかを判定する。
	 * 
	 * @param player1
	 *            判定対象プレイヤー1
	 * @param player2
	 *            判定対象プレイヤー2
	 * @return 勝ったプレイヤー。引き分けの場合は null を返す。
	 */
    private Player judgeJanken(Player player1, Player player2)
    {
        Player winner = null;

        // プレイヤー１の手を出す
        // ★ 修正
        Hand player1hand = player1.showHand();

        // プレイヤー２の手を出す
     // ★ 修正
        Hand player2hand = player2.showHand();

        // それぞれの手を表示する
     // ★ 修正
        System.out.print(player1hand);
        System.out.print(" vs. ");
     // ★ 修正
        System.out.print(player2hand);
        System.out.print("\n");

        // プレイヤー１が勝つ場合
        if ((player1hand == Hand.STONE && player2hand == Hand.SCISSORS)
            || (player1hand == Hand.SCISSORS && player2hand == Hand.PAPER)
            || (player1hand == Hand.PAPER && player2hand == Hand.STONE))
        {
            winner = player1;
        }
        // プレイヤー２が勝つ場合
        else if (
            (player1hand == Hand.STONE && player2hand == Hand.PAPER)
                || (player1hand == Hand.SCISSORS && player2hand == Hand.STONE)
                || (player1hand == Hand.PAPER
                    && player2hand == Hand.SCISSORS))
        {
            winner = player2;
        }

        // どちらでもない場合は引き分け(nullを返す)

        return winner;
    }

    /**
	 * 最終的な勝者を判定する。
	 * 
	 * @param player1
	 *            判定対象プレイヤー1
	 * @param player2
	 *            判定対象プレイヤー2
	 * @return 勝ったプレイヤー。引き分けの場合は null を返す。
	 */
    private Player judgeFinalWinner(Player player1, Player player2)
    {
        Player winner = null;

        // Player1から勝ち数を聞く
        int player1WinCount = player1.getWinCount();

        // Player2から勝ち数を聞く
        int player2WinCount = player2.getWinCount();

        if (player1WinCount > player2WinCount)
        {
            // プレイヤー1の勝ち
            winner = player1;
        }
        else if (player1WinCount < player2WinCount)
        {
            // プレイヤー2の勝ち
            winner = player2;
        }

        // どちらでもない場合は引き分け(nullを返す)

        return winner;
    }

    /**
	 * ジャンケンの手を表示する。
	 * 
	 * @param hand
	 *            ジャンケンの手
	 */
    /*
	 * ★ 廃止しました private void printHand(Hand hand) { switch (hand) { case
	 * Hand.STONE : System.out.print("STONE"); break;
	 * 
	 * case Hand.SCISSORS : System.out.print("SCISSORS"); break;
	 * 
	 * case Hand.PAPER : System.out.print("PAPER"); break;
	 * 
	 * default : break; }
	 * }
	 */
    }
